/*
 * Data API
 *
 * Cognitive Credit Company Data API
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Threading;
using RestSharp;
using Org.OpenAPITools.Client;
using Org.OpenAPITools.Model;

namespace Org.OpenAPITools.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IDefaultApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Get company comparables
        /// </summary>
        /// <remarks>
        /// Returns comparables data for a list of companies for the allowed coverage_universe
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="interval">identifier for the interval of comparables data to fetch</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return comparables snapshot for (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>ComparablesResponse</returns>
        ComparablesResponse ApiConsumerProjectLocalGetCompanyComparablesSubtypes (string interval, DateTime? atTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string));

        /// <summary>
        /// Get company comparables
        /// </summary>
        /// <remarks>
        /// Returns comparables data for a list of companies for the allowed coverage_universe
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="interval">identifier for the interval of comparables data to fetch</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return comparables snapshot for (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>ApiResponse of ComparablesResponse</returns>
        ApiResponse<ComparablesResponse> ApiConsumerProjectLocalGetCompanyComparablesSubtypesWithHttpInfo (string interval, DateTime? atTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string));
        /// <summary>
        /// Get a company datapoint
        /// </summary>
        /// <remarks>
        /// Returns details of an individual datapoint for a company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="datapointId">identifier for the datapoint</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>CompanyDatapointResponse</returns>
        CompanyDatapointResponse ApiConsumerProjectLocalGetCompanyDatapoint (string datapointId, string acceptEncoding = default(string));

        /// <summary>
        /// Get a company datapoint
        /// </summary>
        /// <remarks>
        /// Returns details of an individual datapoint for a company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="datapointId">identifier for the datapoint</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>ApiResponse of CompanyDatapointResponse</returns>
        ApiResponse<CompanyDatapointResponse> ApiConsumerProjectLocalGetCompanyDatapointWithHttpInfo (string datapointId, string acceptEncoding = default(string));
        /// <summary>
        /// Get company financials
        /// </summary>
        /// <remarks>
        /// Returns historical financials data for single company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return financials snapshot for (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>CompanyFinancialsResponse</returns>
        CompanyFinancialsResponse ApiConsumerProjectLocalGetCompanyFinancials (string companyId, DateTime? atTimestamp = default(DateTime?), string acceptEncoding = default(string));

        /// <summary>
        /// Get company financials
        /// </summary>
        /// <remarks>
        /// Returns historical financials data for single company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return financials snapshot for (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>ApiResponse of CompanyFinancialsResponse</returns>
        ApiResponse<CompanyFinancialsResponse> ApiConsumerProjectLocalGetCompanyFinancialsWithHttpInfo (string companyId, DateTime? atTimestamp = default(DateTime?), string acceptEncoding = default(string));
        /// <summary>
        /// Get company descriptions
        /// </summary>
        /// <remarks>
        /// Returns a list of company description objects.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return companies snapshot for (optional)</param>
        /// <param name="isRetired">filter by &#39;retired&#39; status - (true|false) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids - comma separated list (optional)</param>
        /// <param name="tickers">filter by supplied company tickers (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="updatedAfter">Only return company descriptions added or updated on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="updatedBefore">Only return company descriptions added or updated before this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateAfter">Only return company descriptions for companies with reports on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateBefore">Only return company descriptions for companies with reports before this ISO-8601 timestamp (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>CompanyDescriptionResponse</returns>
        CompanyDescriptionResponse ApiConsumerProjectLocalGetCompanyListings (DateTime? atTimestamp = default(DateTime?), string isRetired = default(string), string companyIds = default(string), string tickers = default(string), int? limit = default(int?), DateTime? updatedAfter = default(DateTime?), DateTime? updatedBefore = default(DateTime?), DateTime? lastReportedDateAfter = default(DateTime?), DateTime? lastReportedDateBefore = default(DateTime?), string continuationToken = default(string), string acceptEncoding = default(string));

        /// <summary>
        /// Get company descriptions
        /// </summary>
        /// <remarks>
        /// Returns a list of company description objects.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return companies snapshot for (optional)</param>
        /// <param name="isRetired">filter by &#39;retired&#39; status - (true|false) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids - comma separated list (optional)</param>
        /// <param name="tickers">filter by supplied company tickers (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="updatedAfter">Only return company descriptions added or updated on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="updatedBefore">Only return company descriptions added or updated before this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateAfter">Only return company descriptions for companies with reports on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateBefore">Only return company descriptions for companies with reports before this ISO-8601 timestamp (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>ApiResponse of CompanyDescriptionResponse</returns>
        ApiResponse<CompanyDescriptionResponse> ApiConsumerProjectLocalGetCompanyListingsWithHttpInfo (DateTime? atTimestamp = default(DateTime?), string isRetired = default(string), string companyIds = default(string), string tickers = default(string), int? limit = default(int?), DateTime? updatedAfter = default(DateTime?), DateTime? updatedBefore = default(DateTime?), DateTime? lastReportedDateAfter = default(DateTime?), DateTime? lastReportedDateBefore = default(DateTime?), string continuationToken = default(string), string acceptEncoding = default(string));
        /// <summary>
        /// Get company time series
        /// </summary>
        /// <remarks>
        /// Returns all historical values of a specific comparable for a given company and interval
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch time series data for</param>
        /// <param name="tag">identifier for the comparable tag to fetch time series data for</param>
        /// <param name="interval">identifier for the interval to fetch time series data for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>CompanyTimeSeriesResponse</returns>
        CompanyTimeSeriesResponse ApiConsumerProjectLocalGetCompanyTimeSeries (string companyId, string tag, string interval, string acceptEncoding = default(string));

        /// <summary>
        /// Get company time series
        /// </summary>
        /// <remarks>
        /// Returns all historical values of a specific comparable for a given company and interval
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch time series data for</param>
        /// <param name="tag">identifier for the comparable tag to fetch time series data for</param>
        /// <param name="interval">identifier for the interval to fetch time series data for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>ApiResponse of CompanyTimeSeriesResponse</returns>
        ApiResponse<CompanyTimeSeriesResponse> ApiConsumerProjectLocalGetCompanyTimeSeriesWithHttpInfo (string companyId, string tag, string interval, string acceptEncoding = default(string));
        /// <summary>
        /// Get company comparables updates for a given time period
        /// </summary>
        /// <remarks>
        /// Returns comparables data for a list of companies for the allowed coverage_universe, from a given start timestamp and optional end timestamp
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="startTimestamp">ISO-8601 Timestamp to return comparables updates since (all updates greater than or equal to the timestamp) (optional)</param>
        /// <param name="endTimestamp">ISO-8601 Timestamp to return comparables updates until (all updates less than, but not equal to, the timestamp) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>ComparablesResponse</returns>
        ComparablesResponse ApiConsumerProjectLocalGetComparablesUpdatesSince (DateTime? startTimestamp = default(DateTime?), DateTime? endTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string));

        /// <summary>
        /// Get company comparables updates for a given time period
        /// </summary>
        /// <remarks>
        /// Returns comparables data for a list of companies for the allowed coverage_universe, from a given start timestamp and optional end timestamp
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="startTimestamp">ISO-8601 Timestamp to return comparables updates since (all updates greater than or equal to the timestamp) (optional)</param>
        /// <param name="endTimestamp">ISO-8601 Timestamp to return comparables updates until (all updates less than, but not equal to, the timestamp) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>ApiResponse of ComparablesResponse</returns>
        ApiResponse<ComparablesResponse> ApiConsumerProjectLocalGetComparablesUpdatesSinceWithHttpInfo (DateTime? startTimestamp = default(DateTime?), DateTime? endTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string));
        /// <summary>
        /// Get company period dates
        /// </summary>
        /// <remarks>
        /// Returns end dates of financial reporting periods for given company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>CompanyPeriodDatesResponse</returns>
        CompanyPeriodDatesResponse ApiConsumerProjectLocalGetPeriodDates (string companyId, string acceptEncoding = default(string));

        /// <summary>
        /// Get company period dates
        /// </summary>
        /// <remarks>
        /// Returns end dates of financial reporting periods for given company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>ApiResponse of CompanyPeriodDatesResponse</returns>
        ApiResponse<CompanyPeriodDatesResponse> ApiConsumerProjectLocalGetPeriodDatesWithHttpInfo (string companyId, string acceptEncoding = default(string));
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Get company comparables
        /// </summary>
        /// <remarks>
        /// Returns comparables data for a list of companies for the allowed coverage_universe
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="interval">identifier for the interval of comparables data to fetch</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return comparables snapshot for (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of ComparablesResponse</returns>
        System.Threading.Tasks.Task<ComparablesResponse> ApiConsumerProjectLocalGetCompanyComparablesSubtypesAsync (string interval, DateTime? atTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get company comparables
        /// </summary>
        /// <remarks>
        /// Returns comparables data for a list of companies for the allowed coverage_universe
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="interval">identifier for the interval of comparables data to fetch</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return comparables snapshot for (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of ApiResponse (ComparablesResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<ComparablesResponse>> ApiConsumerProjectLocalGetCompanyComparablesSubtypesWithHttpInfoAsync (string interval, DateTime? atTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// Get a company datapoint
        /// </summary>
        /// <remarks>
        /// Returns details of an individual datapoint for a company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="datapointId">identifier for the datapoint</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of CompanyDatapointResponse</returns>
        System.Threading.Tasks.Task<CompanyDatapointResponse> ApiConsumerProjectLocalGetCompanyDatapointAsync (string datapointId, string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get a company datapoint
        /// </summary>
        /// <remarks>
        /// Returns details of an individual datapoint for a company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="datapointId">identifier for the datapoint</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of ApiResponse (CompanyDatapointResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<CompanyDatapointResponse>> ApiConsumerProjectLocalGetCompanyDatapointWithHttpInfoAsync (string datapointId, string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// Get company financials
        /// </summary>
        /// <remarks>
        /// Returns historical financials data for single company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return financials snapshot for (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of CompanyFinancialsResponse</returns>
        System.Threading.Tasks.Task<CompanyFinancialsResponse> ApiConsumerProjectLocalGetCompanyFinancialsAsync (string companyId, DateTime? atTimestamp = default(DateTime?), string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get company financials
        /// </summary>
        /// <remarks>
        /// Returns historical financials data for single company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return financials snapshot for (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of ApiResponse (CompanyFinancialsResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<CompanyFinancialsResponse>> ApiConsumerProjectLocalGetCompanyFinancialsWithHttpInfoAsync (string companyId, DateTime? atTimestamp = default(DateTime?), string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// Get company descriptions
        /// </summary>
        /// <remarks>
        /// Returns a list of company description objects.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return companies snapshot for (optional)</param>
        /// <param name="isRetired">filter by &#39;retired&#39; status - (true|false) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids - comma separated list (optional)</param>
        /// <param name="tickers">filter by supplied company tickers (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="updatedAfter">Only return company descriptions added or updated on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="updatedBefore">Only return company descriptions added or updated before this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateAfter">Only return company descriptions for companies with reports on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateBefore">Only return company descriptions for companies with reports before this ISO-8601 timestamp (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of CompanyDescriptionResponse</returns>
        System.Threading.Tasks.Task<CompanyDescriptionResponse> ApiConsumerProjectLocalGetCompanyListingsAsync (DateTime? atTimestamp = default(DateTime?), string isRetired = default(string), string companyIds = default(string), string tickers = default(string), int? limit = default(int?), DateTime? updatedAfter = default(DateTime?), DateTime? updatedBefore = default(DateTime?), DateTime? lastReportedDateAfter = default(DateTime?), DateTime? lastReportedDateBefore = default(DateTime?), string continuationToken = default(string), string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get company descriptions
        /// </summary>
        /// <remarks>
        /// Returns a list of company description objects.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return companies snapshot for (optional)</param>
        /// <param name="isRetired">filter by &#39;retired&#39; status - (true|false) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids - comma separated list (optional)</param>
        /// <param name="tickers">filter by supplied company tickers (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="updatedAfter">Only return company descriptions added or updated on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="updatedBefore">Only return company descriptions added or updated before this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateAfter">Only return company descriptions for companies with reports on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateBefore">Only return company descriptions for companies with reports before this ISO-8601 timestamp (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of ApiResponse (CompanyDescriptionResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<CompanyDescriptionResponse>> ApiConsumerProjectLocalGetCompanyListingsWithHttpInfoAsync (DateTime? atTimestamp = default(DateTime?), string isRetired = default(string), string companyIds = default(string), string tickers = default(string), int? limit = default(int?), DateTime? updatedAfter = default(DateTime?), DateTime? updatedBefore = default(DateTime?), DateTime? lastReportedDateAfter = default(DateTime?), DateTime? lastReportedDateBefore = default(DateTime?), string continuationToken = default(string), string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// Get company time series
        /// </summary>
        /// <remarks>
        /// Returns all historical values of a specific comparable for a given company and interval
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch time series data for</param>
        /// <param name="tag">identifier for the comparable tag to fetch time series data for</param>
        /// <param name="interval">identifier for the interval to fetch time series data for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of CompanyTimeSeriesResponse</returns>
        System.Threading.Tasks.Task<CompanyTimeSeriesResponse> ApiConsumerProjectLocalGetCompanyTimeSeriesAsync (string companyId, string tag, string interval, string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get company time series
        /// </summary>
        /// <remarks>
        /// Returns all historical values of a specific comparable for a given company and interval
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch time series data for</param>
        /// <param name="tag">identifier for the comparable tag to fetch time series data for</param>
        /// <param name="interval">identifier for the interval to fetch time series data for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of ApiResponse (CompanyTimeSeriesResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<CompanyTimeSeriesResponse>> ApiConsumerProjectLocalGetCompanyTimeSeriesWithHttpInfoAsync (string companyId, string tag, string interval, string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// Get company comparables updates for a given time period
        /// </summary>
        /// <remarks>
        /// Returns comparables data for a list of companies for the allowed coverage_universe, from a given start timestamp and optional end timestamp
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="startTimestamp">ISO-8601 Timestamp to return comparables updates since (all updates greater than or equal to the timestamp) (optional)</param>
        /// <param name="endTimestamp">ISO-8601 Timestamp to return comparables updates until (all updates less than, but not equal to, the timestamp) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of ComparablesResponse</returns>
        System.Threading.Tasks.Task<ComparablesResponse> ApiConsumerProjectLocalGetComparablesUpdatesSinceAsync (DateTime? startTimestamp = default(DateTime?), DateTime? endTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get company comparables updates for a given time period
        /// </summary>
        /// <remarks>
        /// Returns comparables data for a list of companies for the allowed coverage_universe, from a given start timestamp and optional end timestamp
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="startTimestamp">ISO-8601 Timestamp to return comparables updates since (all updates greater than or equal to the timestamp) (optional)</param>
        /// <param name="endTimestamp">ISO-8601 Timestamp to return comparables updates until (all updates less than, but not equal to, the timestamp) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of ApiResponse (ComparablesResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<ComparablesResponse>> ApiConsumerProjectLocalGetComparablesUpdatesSinceWithHttpInfoAsync (DateTime? startTimestamp = default(DateTime?), DateTime? endTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// Get company period dates
        /// </summary>
        /// <remarks>
        /// Returns end dates of financial reporting periods for given company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of CompanyPeriodDatesResponse</returns>
        System.Threading.Tasks.Task<CompanyPeriodDatesResponse> ApiConsumerProjectLocalGetPeriodDatesAsync (string companyId, string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get company period dates
        /// </summary>
        /// <remarks>
        /// Returns end dates of financial reporting periods for given company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of ApiResponse (CompanyPeriodDatesResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<CompanyPeriodDatesResponse>> ApiConsumerProjectLocalGetPeriodDatesWithHttpInfoAsync (string companyId, string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken));
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class DefaultApi : IDefaultApi
    {
        private Org.OpenAPITools.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="DefaultApi"/> class.
        /// </summary>
        /// <returns></returns>
        public DefaultApi(String basePath)
        {
            this.Configuration = new Org.OpenAPITools.Client.Configuration { BasePath = basePath };

            ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DefaultApi"/> class
        /// </summary>
        /// <returns></returns>
        public DefaultApi()
        {
            this.Configuration = Org.OpenAPITools.Client.Configuration.Default;

            ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DefaultApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public DefaultApi(Org.OpenAPITools.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = Org.OpenAPITools.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Org.OpenAPITools.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public Org.OpenAPITools.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Get company comparables Returns comparables data for a list of companies for the allowed coverage_universe
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="interval">identifier for the interval of comparables data to fetch</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return comparables snapshot for (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>ComparablesResponse</returns>
        public ComparablesResponse ApiConsumerProjectLocalGetCompanyComparablesSubtypes (string interval, DateTime? atTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string))
        {
             ApiResponse<ComparablesResponse> localVarResponse = ApiConsumerProjectLocalGetCompanyComparablesSubtypesWithHttpInfo(interval, atTimestamp, companyIds, limit, continuationToken, acceptEncoding);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get company comparables Returns comparables data for a list of companies for the allowed coverage_universe
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="interval">identifier for the interval of comparables data to fetch</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return comparables snapshot for (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>ApiResponse of ComparablesResponse</returns>
        public ApiResponse<ComparablesResponse> ApiConsumerProjectLocalGetCompanyComparablesSubtypesWithHttpInfo (string interval, DateTime? atTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string))
        {
            // verify the required parameter 'interval' is set
            if (interval == null)
                throw new ApiException(400, "Missing required parameter 'interval' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyComparablesSubtypes");

            var localVarPath = "/comparables/{interval}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (interval != null) localVarPathParams.Add("interval", this.Configuration.ApiClient.ParameterToString(interval)); // path parameter
            if (atTimestamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "at_timestamp", atTimestamp)); // query parameter
            if (companyIds != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "company_ids", companyIds)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (continuationToken != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "continuation_token", continuationToken)); // query parameter
            if (acceptEncoding != null) localVarHeaderParams.Add("Accept-Encoding", this.Configuration.ApiClient.ParameterToString(acceptEncoding)); // header parameter

            // authentication (authorizeClient) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarHeaderParams["x-api-key"] = this.Configuration.GetApiKeyWithPrefix("x-api-key");
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiConsumerProjectLocalGetCompanyComparablesSubtypes", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ComparablesResponse>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ComparablesResponse) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ComparablesResponse)));
        }

        /// <summary>
        /// Get company comparables Returns comparables data for a list of companies for the allowed coverage_universe
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="interval">identifier for the interval of comparables data to fetch</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return comparables snapshot for (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of ComparablesResponse</returns>
        public async System.Threading.Tasks.Task<ComparablesResponse> ApiConsumerProjectLocalGetCompanyComparablesSubtypesAsync (string interval, DateTime? atTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken))
        {
             ApiResponse<ComparablesResponse> localVarResponse = await ApiConsumerProjectLocalGetCompanyComparablesSubtypesWithHttpInfoAsync(interval, atTimestamp, companyIds, limit, continuationToken, acceptEncoding, cancellationToken);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get company comparables Returns comparables data for a list of companies for the allowed coverage_universe
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="interval">identifier for the interval of comparables data to fetch</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return comparables snapshot for (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of ApiResponse (ComparablesResponse)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ComparablesResponse>> ApiConsumerProjectLocalGetCompanyComparablesSubtypesWithHttpInfoAsync (string interval, DateTime? atTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken))
        {
            // verify the required parameter 'interval' is set
            if (interval == null)
                throw new ApiException(400, "Missing required parameter 'interval' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyComparablesSubtypes");

            var localVarPath = "/comparables/{interval}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (interval != null) localVarPathParams.Add("interval", this.Configuration.ApiClient.ParameterToString(interval)); // path parameter
            if (atTimestamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "at_timestamp", atTimestamp)); // query parameter
            if (companyIds != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "company_ids", companyIds)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (continuationToken != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "continuation_token", continuationToken)); // query parameter
            if (acceptEncoding != null) localVarHeaderParams.Add("Accept-Encoding", this.Configuration.ApiClient.ParameterToString(acceptEncoding)); // header parameter

            // authentication (authorizeClient) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarHeaderParams["x-api-key"] = this.Configuration.GetApiKeyWithPrefix("x-api-key");
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType, cancellationToken);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiConsumerProjectLocalGetCompanyComparablesSubtypes", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ComparablesResponse>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ComparablesResponse) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ComparablesResponse)));
        }

        /// <summary>
        /// Get a company datapoint Returns details of an individual datapoint for a company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="datapointId">identifier for the datapoint</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>CompanyDatapointResponse</returns>
        public CompanyDatapointResponse ApiConsumerProjectLocalGetCompanyDatapoint (string datapointId, string acceptEncoding = default(string))
        {
             ApiResponse<CompanyDatapointResponse> localVarResponse = ApiConsumerProjectLocalGetCompanyDatapointWithHttpInfo(datapointId, acceptEncoding);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get a company datapoint Returns details of an individual datapoint for a company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="datapointId">identifier for the datapoint</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>ApiResponse of CompanyDatapointResponse</returns>
        public ApiResponse<CompanyDatapointResponse> ApiConsumerProjectLocalGetCompanyDatapointWithHttpInfo (string datapointId, string acceptEncoding = default(string))
        {
            // verify the required parameter 'datapointId' is set
            if (datapointId == null)
                throw new ApiException(400, "Missing required parameter 'datapointId' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyDatapoint");

            var localVarPath = "/datapoints/{datapointId}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (datapointId != null) localVarPathParams.Add("datapointId", this.Configuration.ApiClient.ParameterToString(datapointId)); // path parameter
            if (acceptEncoding != null) localVarHeaderParams.Add("Accept-Encoding", this.Configuration.ApiClient.ParameterToString(acceptEncoding)); // header parameter

            // authentication (authorizeClient) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarHeaderParams["x-api-key"] = this.Configuration.GetApiKeyWithPrefix("x-api-key");
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiConsumerProjectLocalGetCompanyDatapoint", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CompanyDatapointResponse>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (CompanyDatapointResponse) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CompanyDatapointResponse)));
        }

        /// <summary>
        /// Get a company datapoint Returns details of an individual datapoint for a company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="datapointId">identifier for the datapoint</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of CompanyDatapointResponse</returns>
        public async System.Threading.Tasks.Task<CompanyDatapointResponse> ApiConsumerProjectLocalGetCompanyDatapointAsync (string datapointId, string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken))
        {
             ApiResponse<CompanyDatapointResponse> localVarResponse = await ApiConsumerProjectLocalGetCompanyDatapointWithHttpInfoAsync(datapointId, acceptEncoding, cancellationToken);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get a company datapoint Returns details of an individual datapoint for a company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="datapointId">identifier for the datapoint</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of ApiResponse (CompanyDatapointResponse)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<CompanyDatapointResponse>> ApiConsumerProjectLocalGetCompanyDatapointWithHttpInfoAsync (string datapointId, string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken))
        {
            // verify the required parameter 'datapointId' is set
            if (datapointId == null)
                throw new ApiException(400, "Missing required parameter 'datapointId' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyDatapoint");

            var localVarPath = "/datapoints/{datapointId}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (datapointId != null) localVarPathParams.Add("datapointId", this.Configuration.ApiClient.ParameterToString(datapointId)); // path parameter
            if (acceptEncoding != null) localVarHeaderParams.Add("Accept-Encoding", this.Configuration.ApiClient.ParameterToString(acceptEncoding)); // header parameter

            // authentication (authorizeClient) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarHeaderParams["x-api-key"] = this.Configuration.GetApiKeyWithPrefix("x-api-key");
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType, cancellationToken);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiConsumerProjectLocalGetCompanyDatapoint", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CompanyDatapointResponse>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (CompanyDatapointResponse) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CompanyDatapointResponse)));
        }

        /// <summary>
        /// Get company financials Returns historical financials data for single company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return financials snapshot for (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>CompanyFinancialsResponse</returns>
        public CompanyFinancialsResponse ApiConsumerProjectLocalGetCompanyFinancials (string companyId, DateTime? atTimestamp = default(DateTime?), string acceptEncoding = default(string))
        {
             ApiResponse<CompanyFinancialsResponse> localVarResponse = ApiConsumerProjectLocalGetCompanyFinancialsWithHttpInfo(companyId, atTimestamp, acceptEncoding);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get company financials Returns historical financials data for single company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return financials snapshot for (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>ApiResponse of CompanyFinancialsResponse</returns>
        public ApiResponse<CompanyFinancialsResponse> ApiConsumerProjectLocalGetCompanyFinancialsWithHttpInfo (string companyId, DateTime? atTimestamp = default(DateTime?), string acceptEncoding = default(string))
        {
            // verify the required parameter 'companyId' is set
            if (companyId == null)
                throw new ApiException(400, "Missing required parameter 'companyId' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyFinancials");

            var localVarPath = "/companies/{companyId}/financials";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (companyId != null) localVarPathParams.Add("companyId", this.Configuration.ApiClient.ParameterToString(companyId)); // path parameter
            if (atTimestamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "at_timestamp", atTimestamp)); // query parameter
            if (acceptEncoding != null) localVarHeaderParams.Add("Accept-Encoding", this.Configuration.ApiClient.ParameterToString(acceptEncoding)); // header parameter

            // authentication (authorizeClient) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarHeaderParams["x-api-key"] = this.Configuration.GetApiKeyWithPrefix("x-api-key");
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiConsumerProjectLocalGetCompanyFinancials", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CompanyFinancialsResponse>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (CompanyFinancialsResponse) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CompanyFinancialsResponse)));
        }

        /// <summary>
        /// Get company financials Returns historical financials data for single company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return financials snapshot for (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of CompanyFinancialsResponse</returns>
        public async System.Threading.Tasks.Task<CompanyFinancialsResponse> ApiConsumerProjectLocalGetCompanyFinancialsAsync (string companyId, DateTime? atTimestamp = default(DateTime?), string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken))
        {
             ApiResponse<CompanyFinancialsResponse> localVarResponse = await ApiConsumerProjectLocalGetCompanyFinancialsWithHttpInfoAsync(companyId, atTimestamp, acceptEncoding, cancellationToken);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get company financials Returns historical financials data for single company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return financials snapshot for (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of ApiResponse (CompanyFinancialsResponse)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<CompanyFinancialsResponse>> ApiConsumerProjectLocalGetCompanyFinancialsWithHttpInfoAsync (string companyId, DateTime? atTimestamp = default(DateTime?), string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken))
        {
            // verify the required parameter 'companyId' is set
            if (companyId == null)
                throw new ApiException(400, "Missing required parameter 'companyId' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyFinancials");

            var localVarPath = "/companies/{companyId}/financials";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (companyId != null) localVarPathParams.Add("companyId", this.Configuration.ApiClient.ParameterToString(companyId)); // path parameter
            if (atTimestamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "at_timestamp", atTimestamp)); // query parameter
            if (acceptEncoding != null) localVarHeaderParams.Add("Accept-Encoding", this.Configuration.ApiClient.ParameterToString(acceptEncoding)); // header parameter

            // authentication (authorizeClient) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarHeaderParams["x-api-key"] = this.Configuration.GetApiKeyWithPrefix("x-api-key");
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType, cancellationToken);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiConsumerProjectLocalGetCompanyFinancials", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CompanyFinancialsResponse>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (CompanyFinancialsResponse) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CompanyFinancialsResponse)));
        }

        /// <summary>
        /// Get company descriptions Returns a list of company description objects.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return companies snapshot for (optional)</param>
        /// <param name="isRetired">filter by &#39;retired&#39; status - (true|false) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids - comma separated list (optional)</param>
        /// <param name="tickers">filter by supplied company tickers (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="updatedAfter">Only return company descriptions added or updated on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="updatedBefore">Only return company descriptions added or updated before this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateAfter">Only return company descriptions for companies with reports on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateBefore">Only return company descriptions for companies with reports before this ISO-8601 timestamp (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>CompanyDescriptionResponse</returns>
        public CompanyDescriptionResponse ApiConsumerProjectLocalGetCompanyListings (DateTime? atTimestamp = default(DateTime?), string isRetired = default(string), string companyIds = default(string), string tickers = default(string), int? limit = default(int?), DateTime? updatedAfter = default(DateTime?), DateTime? updatedBefore = default(DateTime?), DateTime? lastReportedDateAfter = default(DateTime?), DateTime? lastReportedDateBefore = default(DateTime?), string continuationToken = default(string), string acceptEncoding = default(string))
        {
             ApiResponse<CompanyDescriptionResponse> localVarResponse = ApiConsumerProjectLocalGetCompanyListingsWithHttpInfo(atTimestamp, isRetired, companyIds, tickers, limit, updatedAfter, updatedBefore, lastReportedDateAfter, lastReportedDateBefore, continuationToken, acceptEncoding);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get company descriptions Returns a list of company description objects.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return companies snapshot for (optional)</param>
        /// <param name="isRetired">filter by &#39;retired&#39; status - (true|false) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids - comma separated list (optional)</param>
        /// <param name="tickers">filter by supplied company tickers (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="updatedAfter">Only return company descriptions added or updated on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="updatedBefore">Only return company descriptions added or updated before this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateAfter">Only return company descriptions for companies with reports on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateBefore">Only return company descriptions for companies with reports before this ISO-8601 timestamp (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>ApiResponse of CompanyDescriptionResponse</returns>
        public ApiResponse<CompanyDescriptionResponse> ApiConsumerProjectLocalGetCompanyListingsWithHttpInfo (DateTime? atTimestamp = default(DateTime?), string isRetired = default(string), string companyIds = default(string), string tickers = default(string), int? limit = default(int?), DateTime? updatedAfter = default(DateTime?), DateTime? updatedBefore = default(DateTime?), DateTime? lastReportedDateAfter = default(DateTime?), DateTime? lastReportedDateBefore = default(DateTime?), string continuationToken = default(string), string acceptEncoding = default(string))
        {

            var localVarPath = "/companies";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (atTimestamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "at_timestamp", atTimestamp)); // query parameter
            if (isRetired != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "is_retired", isRetired)); // query parameter
            if (companyIds != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "company_ids", companyIds)); // query parameter
            if (tickers != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "tickers", tickers)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (updatedAfter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "updated_after", updatedAfter)); // query parameter
            if (updatedBefore != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "updated_before", updatedBefore)); // query parameter
            if (lastReportedDateAfter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "last_reported_date_after", lastReportedDateAfter)); // query parameter
            if (lastReportedDateBefore != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "last_reported_date_before", lastReportedDateBefore)); // query parameter
            if (continuationToken != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "continuation_token", continuationToken)); // query parameter
            if (acceptEncoding != null) localVarHeaderParams.Add("Accept-Encoding", this.Configuration.ApiClient.ParameterToString(acceptEncoding)); // header parameter

            // authentication (authorizeClient) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarHeaderParams["x-api-key"] = this.Configuration.GetApiKeyWithPrefix("x-api-key");
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiConsumerProjectLocalGetCompanyListings", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CompanyDescriptionResponse>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (CompanyDescriptionResponse) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CompanyDescriptionResponse)));
        }

        /// <summary>
        /// Get company descriptions Returns a list of company description objects.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return companies snapshot for (optional)</param>
        /// <param name="isRetired">filter by &#39;retired&#39; status - (true|false) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids - comma separated list (optional)</param>
        /// <param name="tickers">filter by supplied company tickers (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="updatedAfter">Only return company descriptions added or updated on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="updatedBefore">Only return company descriptions added or updated before this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateAfter">Only return company descriptions for companies with reports on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateBefore">Only return company descriptions for companies with reports before this ISO-8601 timestamp (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of CompanyDescriptionResponse</returns>
        public async System.Threading.Tasks.Task<CompanyDescriptionResponse> ApiConsumerProjectLocalGetCompanyListingsAsync (DateTime? atTimestamp = default(DateTime?), string isRetired = default(string), string companyIds = default(string), string tickers = default(string), int? limit = default(int?), DateTime? updatedAfter = default(DateTime?), DateTime? updatedBefore = default(DateTime?), DateTime? lastReportedDateAfter = default(DateTime?), DateTime? lastReportedDateBefore = default(DateTime?), string continuationToken = default(string), string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken))
        {
             ApiResponse<CompanyDescriptionResponse> localVarResponse = await ApiConsumerProjectLocalGetCompanyListingsWithHttpInfoAsync(atTimestamp, isRetired, companyIds, tickers, limit, updatedAfter, updatedBefore, lastReportedDateAfter, lastReportedDateBefore, continuationToken, acceptEncoding, cancellationToken);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get company descriptions Returns a list of company description objects.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return companies snapshot for (optional)</param>
        /// <param name="isRetired">filter by &#39;retired&#39; status - (true|false) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids - comma separated list (optional)</param>
        /// <param name="tickers">filter by supplied company tickers (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="updatedAfter">Only return company descriptions added or updated on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="updatedBefore">Only return company descriptions added or updated before this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateAfter">Only return company descriptions for companies with reports on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateBefore">Only return company descriptions for companies with reports before this ISO-8601 timestamp (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of ApiResponse (CompanyDescriptionResponse)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<CompanyDescriptionResponse>> ApiConsumerProjectLocalGetCompanyListingsWithHttpInfoAsync (DateTime? atTimestamp = default(DateTime?), string isRetired = default(string), string companyIds = default(string), string tickers = default(string), int? limit = default(int?), DateTime? updatedAfter = default(DateTime?), DateTime? updatedBefore = default(DateTime?), DateTime? lastReportedDateAfter = default(DateTime?), DateTime? lastReportedDateBefore = default(DateTime?), string continuationToken = default(string), string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken))
        {

            var localVarPath = "/companies";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (atTimestamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "at_timestamp", atTimestamp)); // query parameter
            if (isRetired != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "is_retired", isRetired)); // query parameter
            if (companyIds != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "company_ids", companyIds)); // query parameter
            if (tickers != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "tickers", tickers)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (updatedAfter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "updated_after", updatedAfter)); // query parameter
            if (updatedBefore != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "updated_before", updatedBefore)); // query parameter
            if (lastReportedDateAfter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "last_reported_date_after", lastReportedDateAfter)); // query parameter
            if (lastReportedDateBefore != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "last_reported_date_before", lastReportedDateBefore)); // query parameter
            if (continuationToken != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "continuation_token", continuationToken)); // query parameter
            if (acceptEncoding != null) localVarHeaderParams.Add("Accept-Encoding", this.Configuration.ApiClient.ParameterToString(acceptEncoding)); // header parameter

            // authentication (authorizeClient) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarHeaderParams["x-api-key"] = this.Configuration.GetApiKeyWithPrefix("x-api-key");
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType, cancellationToken);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiConsumerProjectLocalGetCompanyListings", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CompanyDescriptionResponse>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (CompanyDescriptionResponse) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CompanyDescriptionResponse)));
        }

        /// <summary>
        /// Get company time series Returns all historical values of a specific comparable for a given company and interval
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch time series data for</param>
        /// <param name="tag">identifier for the comparable tag to fetch time series data for</param>
        /// <param name="interval">identifier for the interval to fetch time series data for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>CompanyTimeSeriesResponse</returns>
        public CompanyTimeSeriesResponse ApiConsumerProjectLocalGetCompanyTimeSeries (string companyId, string tag, string interval, string acceptEncoding = default(string))
        {
             ApiResponse<CompanyTimeSeriesResponse> localVarResponse = ApiConsumerProjectLocalGetCompanyTimeSeriesWithHttpInfo(companyId, tag, interval, acceptEncoding);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get company time series Returns all historical values of a specific comparable for a given company and interval
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch time series data for</param>
        /// <param name="tag">identifier for the comparable tag to fetch time series data for</param>
        /// <param name="interval">identifier for the interval to fetch time series data for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>ApiResponse of CompanyTimeSeriesResponse</returns>
        public ApiResponse<CompanyTimeSeriesResponse> ApiConsumerProjectLocalGetCompanyTimeSeriesWithHttpInfo (string companyId, string tag, string interval, string acceptEncoding = default(string))
        {
            // verify the required parameter 'companyId' is set
            if (companyId == null)
                throw new ApiException(400, "Missing required parameter 'companyId' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyTimeSeries");
            // verify the required parameter 'tag' is set
            if (tag == null)
                throw new ApiException(400, "Missing required parameter 'tag' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyTimeSeries");
            // verify the required parameter 'interval' is set
            if (interval == null)
                throw new ApiException(400, "Missing required parameter 'interval' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyTimeSeries");

            var localVarPath = "/companies/{companyId}/timeseries/{tag}/{interval}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (companyId != null) localVarPathParams.Add("companyId", this.Configuration.ApiClient.ParameterToString(companyId)); // path parameter
            if (tag != null) localVarPathParams.Add("tag", this.Configuration.ApiClient.ParameterToString(tag)); // path parameter
            if (interval != null) localVarPathParams.Add("interval", this.Configuration.ApiClient.ParameterToString(interval)); // path parameter
            if (acceptEncoding != null) localVarHeaderParams.Add("Accept-Encoding", this.Configuration.ApiClient.ParameterToString(acceptEncoding)); // header parameter

            // authentication (authorizeClient) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarHeaderParams["x-api-key"] = this.Configuration.GetApiKeyWithPrefix("x-api-key");
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiConsumerProjectLocalGetCompanyTimeSeries", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CompanyTimeSeriesResponse>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (CompanyTimeSeriesResponse) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CompanyTimeSeriesResponse)));
        }

        /// <summary>
        /// Get company time series Returns all historical values of a specific comparable for a given company and interval
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch time series data for</param>
        /// <param name="tag">identifier for the comparable tag to fetch time series data for</param>
        /// <param name="interval">identifier for the interval to fetch time series data for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of CompanyTimeSeriesResponse</returns>
        public async System.Threading.Tasks.Task<CompanyTimeSeriesResponse> ApiConsumerProjectLocalGetCompanyTimeSeriesAsync (string companyId, string tag, string interval, string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken))
        {
             ApiResponse<CompanyTimeSeriesResponse> localVarResponse = await ApiConsumerProjectLocalGetCompanyTimeSeriesWithHttpInfoAsync(companyId, tag, interval, acceptEncoding, cancellationToken);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get company time series Returns all historical values of a specific comparable for a given company and interval
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch time series data for</param>
        /// <param name="tag">identifier for the comparable tag to fetch time series data for</param>
        /// <param name="interval">identifier for the interval to fetch time series data for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of ApiResponse (CompanyTimeSeriesResponse)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<CompanyTimeSeriesResponse>> ApiConsumerProjectLocalGetCompanyTimeSeriesWithHttpInfoAsync (string companyId, string tag, string interval, string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken))
        {
            // verify the required parameter 'companyId' is set
            if (companyId == null)
                throw new ApiException(400, "Missing required parameter 'companyId' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyTimeSeries");
            // verify the required parameter 'tag' is set
            if (tag == null)
                throw new ApiException(400, "Missing required parameter 'tag' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyTimeSeries");
            // verify the required parameter 'interval' is set
            if (interval == null)
                throw new ApiException(400, "Missing required parameter 'interval' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyTimeSeries");

            var localVarPath = "/companies/{companyId}/timeseries/{tag}/{interval}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (companyId != null) localVarPathParams.Add("companyId", this.Configuration.ApiClient.ParameterToString(companyId)); // path parameter
            if (tag != null) localVarPathParams.Add("tag", this.Configuration.ApiClient.ParameterToString(tag)); // path parameter
            if (interval != null) localVarPathParams.Add("interval", this.Configuration.ApiClient.ParameterToString(interval)); // path parameter
            if (acceptEncoding != null) localVarHeaderParams.Add("Accept-Encoding", this.Configuration.ApiClient.ParameterToString(acceptEncoding)); // header parameter

            // authentication (authorizeClient) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarHeaderParams["x-api-key"] = this.Configuration.GetApiKeyWithPrefix("x-api-key");
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType, cancellationToken);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiConsumerProjectLocalGetCompanyTimeSeries", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CompanyTimeSeriesResponse>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (CompanyTimeSeriesResponse) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CompanyTimeSeriesResponse)));
        }

        /// <summary>
        /// Get company comparables updates for a given time period Returns comparables data for a list of companies for the allowed coverage_universe, from a given start timestamp and optional end timestamp
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="startTimestamp">ISO-8601 Timestamp to return comparables updates since (all updates greater than or equal to the timestamp) (optional)</param>
        /// <param name="endTimestamp">ISO-8601 Timestamp to return comparables updates until (all updates less than, but not equal to, the timestamp) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>ComparablesResponse</returns>
        public ComparablesResponse ApiConsumerProjectLocalGetComparablesUpdatesSince (DateTime? startTimestamp = default(DateTime?), DateTime? endTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string))
        {
             ApiResponse<ComparablesResponse> localVarResponse = ApiConsumerProjectLocalGetComparablesUpdatesSinceWithHttpInfo(startTimestamp, endTimestamp, companyIds, limit, continuationToken, acceptEncoding);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get company comparables updates for a given time period Returns comparables data for a list of companies for the allowed coverage_universe, from a given start timestamp and optional end timestamp
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="startTimestamp">ISO-8601 Timestamp to return comparables updates since (all updates greater than or equal to the timestamp) (optional)</param>
        /// <param name="endTimestamp">ISO-8601 Timestamp to return comparables updates until (all updates less than, but not equal to, the timestamp) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>ApiResponse of ComparablesResponse</returns>
        public ApiResponse<ComparablesResponse> ApiConsumerProjectLocalGetComparablesUpdatesSinceWithHttpInfo (DateTime? startTimestamp = default(DateTime?), DateTime? endTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string))
        {

            var localVarPath = "/comparables/updates";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (startTimestamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "start_timestamp", startTimestamp)); // query parameter
            if (endTimestamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "end_timestamp", endTimestamp)); // query parameter
            if (companyIds != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "company_ids", companyIds)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (continuationToken != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "continuation_token", continuationToken)); // query parameter
            if (acceptEncoding != null) localVarHeaderParams.Add("Accept-Encoding", this.Configuration.ApiClient.ParameterToString(acceptEncoding)); // header parameter

            // authentication (authorizeClient) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarHeaderParams["x-api-key"] = this.Configuration.GetApiKeyWithPrefix("x-api-key");
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiConsumerProjectLocalGetComparablesUpdatesSince", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ComparablesResponse>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ComparablesResponse) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ComparablesResponse)));
        }

        /// <summary>
        /// Get company comparables updates for a given time period Returns comparables data for a list of companies for the allowed coverage_universe, from a given start timestamp and optional end timestamp
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="startTimestamp">ISO-8601 Timestamp to return comparables updates since (all updates greater than or equal to the timestamp) (optional)</param>
        /// <param name="endTimestamp">ISO-8601 Timestamp to return comparables updates until (all updates less than, but not equal to, the timestamp) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of ComparablesResponse</returns>
        public async System.Threading.Tasks.Task<ComparablesResponse> ApiConsumerProjectLocalGetComparablesUpdatesSinceAsync (DateTime? startTimestamp = default(DateTime?), DateTime? endTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken))
        {
             ApiResponse<ComparablesResponse> localVarResponse = await ApiConsumerProjectLocalGetComparablesUpdatesSinceWithHttpInfoAsync(startTimestamp, endTimestamp, companyIds, limit, continuationToken, acceptEncoding, cancellationToken);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get company comparables updates for a given time period Returns comparables data for a list of companies for the allowed coverage_universe, from a given start timestamp and optional end timestamp
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="startTimestamp">ISO-8601 Timestamp to return comparables updates since (all updates greater than or equal to the timestamp) (optional)</param>
        /// <param name="endTimestamp">ISO-8601 Timestamp to return comparables updates until (all updates less than, but not equal to, the timestamp) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of ApiResponse (ComparablesResponse)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ComparablesResponse>> ApiConsumerProjectLocalGetComparablesUpdatesSinceWithHttpInfoAsync (DateTime? startTimestamp = default(DateTime?), DateTime? endTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken))
        {

            var localVarPath = "/comparables/updates";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (startTimestamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "start_timestamp", startTimestamp)); // query parameter
            if (endTimestamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "end_timestamp", endTimestamp)); // query parameter
            if (companyIds != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "company_ids", companyIds)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (continuationToken != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "continuation_token", continuationToken)); // query parameter
            if (acceptEncoding != null) localVarHeaderParams.Add("Accept-Encoding", this.Configuration.ApiClient.ParameterToString(acceptEncoding)); // header parameter

            // authentication (authorizeClient) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarHeaderParams["x-api-key"] = this.Configuration.GetApiKeyWithPrefix("x-api-key");
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType, cancellationToken);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiConsumerProjectLocalGetComparablesUpdatesSince", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ComparablesResponse>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ComparablesResponse) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ComparablesResponse)));
        }

        /// <summary>
        /// Get company period dates Returns end dates of financial reporting periods for given company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>CompanyPeriodDatesResponse</returns>
        public CompanyPeriodDatesResponse ApiConsumerProjectLocalGetPeriodDates (string companyId, string acceptEncoding = default(string))
        {
             ApiResponse<CompanyPeriodDatesResponse> localVarResponse = ApiConsumerProjectLocalGetPeriodDatesWithHttpInfo(companyId, acceptEncoding);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get company period dates Returns end dates of financial reporting periods for given company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <returns>ApiResponse of CompanyPeriodDatesResponse</returns>
        public ApiResponse<CompanyPeriodDatesResponse> ApiConsumerProjectLocalGetPeriodDatesWithHttpInfo (string companyId, string acceptEncoding = default(string))
        {
            // verify the required parameter 'companyId' is set
            if (companyId == null)
                throw new ApiException(400, "Missing required parameter 'companyId' when calling DefaultApi->ApiConsumerProjectLocalGetPeriodDates");

            var localVarPath = "/companies/{companyId}/periods";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (companyId != null) localVarPathParams.Add("companyId", this.Configuration.ApiClient.ParameterToString(companyId)); // path parameter
            if (acceptEncoding != null) localVarHeaderParams.Add("Accept-Encoding", this.Configuration.ApiClient.ParameterToString(acceptEncoding)); // header parameter

            // authentication (authorizeClient) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarHeaderParams["x-api-key"] = this.Configuration.GetApiKeyWithPrefix("x-api-key");
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiConsumerProjectLocalGetPeriodDates", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CompanyPeriodDatesResponse>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (CompanyPeriodDatesResponse) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CompanyPeriodDatesResponse)));
        }

        /// <summary>
        /// Get company period dates Returns end dates of financial reporting periods for given company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of CompanyPeriodDatesResponse</returns>
        public async System.Threading.Tasks.Task<CompanyPeriodDatesResponse> ApiConsumerProjectLocalGetPeriodDatesAsync (string companyId, string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken))
        {
             ApiResponse<CompanyPeriodDatesResponse> localVarResponse = await ApiConsumerProjectLocalGetPeriodDatesWithHttpInfoAsync(companyId, acceptEncoding, cancellationToken);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get company period dates Returns end dates of financial reporting periods for given company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="cancellationToken">Cancellation Token to cancel request (optional) </param>
        /// <returns>Task of ApiResponse (CompanyPeriodDatesResponse)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<CompanyPeriodDatesResponse>> ApiConsumerProjectLocalGetPeriodDatesWithHttpInfoAsync (string companyId, string acceptEncoding = default(string), CancellationToken cancellationToken = default(CancellationToken))
        {
            // verify the required parameter 'companyId' is set
            if (companyId == null)
                throw new ApiException(400, "Missing required parameter 'companyId' when calling DefaultApi->ApiConsumerProjectLocalGetPeriodDates");

            var localVarPath = "/companies/{companyId}/periods";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (companyId != null) localVarPathParams.Add("companyId", this.Configuration.ApiClient.ParameterToString(companyId)); // path parameter
            if (acceptEncoding != null) localVarHeaderParams.Add("Accept-Encoding", this.Configuration.ApiClient.ParameterToString(acceptEncoding)); // header parameter

            // authentication (authorizeClient) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarHeaderParams["x-api-key"] = this.Configuration.GetApiKeyWithPrefix("x-api-key");
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType, cancellationToken);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiConsumerProjectLocalGetPeriodDates", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CompanyPeriodDatesResponse>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (CompanyPeriodDatesResponse) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CompanyPeriodDatesResponse)));
        }

    }
}
