/*
 * Data API
 *
 * Cognitive Credit Company Data API
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// CompanyTimeSeriesResponseData
    /// </summary>
    [DataContract]
    public partial class CompanyTimeSeriesResponseData :  IEquatable<CompanyTimeSeriesResponseData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CompanyTimeSeriesResponseData" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected CompanyTimeSeriesResponseData() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="CompanyTimeSeriesResponseData" /> class.
        /// </summary>
        /// <param name="companyId">companyId (required).</param>
        /// <param name="generatedAt">generatedAt (required).</param>
        /// <param name="interval">interval (required).</param>
        /// <param name="tag">tag (required).</param>
        /// <param name="timeSeries">timeSeries (required).</param>
        /// <param name="updatedAt">updatedAt (required).</param>
        public CompanyTimeSeriesResponseData(string companyId = default(string), DateTime generatedAt = default(DateTime), string interval = default(string), string tag = default(string), List<TimeSeriesInner> timeSeries = default(List<TimeSeriesInner>), DateTime updatedAt = default(DateTime))
        {
            // to ensure "companyId" is required (not null)
            if (companyId == null)
            {
                throw new InvalidDataException("companyId is a required property for CompanyTimeSeriesResponseData and cannot be null");
            }
            else
            {
                this.CompanyId = companyId;
            }

            // to ensure "generatedAt" is required (not null)
            if (generatedAt == null)
            {
                throw new InvalidDataException("generatedAt is a required property for CompanyTimeSeriesResponseData and cannot be null");
            }
            else
            {
                this.GeneratedAt = generatedAt;
            }

            // to ensure "interval" is required (not null)
            if (interval == null)
            {
                throw new InvalidDataException("interval is a required property for CompanyTimeSeriesResponseData and cannot be null");
            }
            else
            {
                this.Interval = interval;
            }

            // to ensure "tag" is required (not null)
            if (tag == null)
            {
                throw new InvalidDataException("tag is a required property for CompanyTimeSeriesResponseData and cannot be null");
            }
            else
            {
                this.Tag = tag;
            }

            // to ensure "timeSeries" is required (not null)
            if (timeSeries == null)
            {
                throw new InvalidDataException("timeSeries is a required property for CompanyTimeSeriesResponseData and cannot be null");
            }
            else
            {
                this.TimeSeries = timeSeries;
            }

            // to ensure "updatedAt" is required (not null)
            if (updatedAt == null)
            {
                throw new InvalidDataException("updatedAt is a required property for CompanyTimeSeriesResponseData and cannot be null");
            }
            else
            {
                this.UpdatedAt = updatedAt;
            }

        }

        /// <summary>
        /// Gets or Sets CompanyId
        /// </summary>
        [DataMember(Name="company_id", EmitDefaultValue=true)]
        public string CompanyId { get; set; }

        /// <summary>
        /// Gets or Sets GeneratedAt
        /// </summary>
        [DataMember(Name="generated_at", EmitDefaultValue=true)]
        public DateTime GeneratedAt { get; set; }

        /// <summary>
        /// Gets or Sets Interval
        /// </summary>
        [DataMember(Name="interval", EmitDefaultValue=true)]
        public string Interval { get; set; }

        /// <summary>
        /// Gets or Sets Tag
        /// </summary>
        [DataMember(Name="tag", EmitDefaultValue=true)]
        public string Tag { get; set; }

        /// <summary>
        /// Gets or Sets TimeSeries
        /// </summary>
        [DataMember(Name="time_series", EmitDefaultValue=true)]
        public List<TimeSeriesInner> TimeSeries { get; set; }

        /// <summary>
        /// Gets or Sets UpdatedAt
        /// </summary>
        [DataMember(Name="updated_at", EmitDefaultValue=true)]
        public DateTime UpdatedAt { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CompanyTimeSeriesResponseData {\n");
            sb.Append("  CompanyId: ").Append(CompanyId).Append("\n");
            sb.Append("  GeneratedAt: ").Append(GeneratedAt).Append("\n");
            sb.Append("  Interval: ").Append(Interval).Append("\n");
            sb.Append("  Tag: ").Append(Tag).Append("\n");
            sb.Append("  TimeSeries: ").Append(TimeSeries).Append("\n");
            sb.Append("  UpdatedAt: ").Append(UpdatedAt).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CompanyTimeSeriesResponseData);
        }

        /// <summary>
        /// Returns true if CompanyTimeSeriesResponseData instances are equal
        /// </summary>
        /// <param name="input">Instance of CompanyTimeSeriesResponseData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CompanyTimeSeriesResponseData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.CompanyId == input.CompanyId ||
                    (this.CompanyId != null &&
                    this.CompanyId.Equals(input.CompanyId))
                ) && 
                (
                    this.GeneratedAt == input.GeneratedAt ||
                    (this.GeneratedAt != null &&
                    this.GeneratedAt.Equals(input.GeneratedAt))
                ) && 
                (
                    this.Interval == input.Interval ||
                    (this.Interval != null &&
                    this.Interval.Equals(input.Interval))
                ) && 
                (
                    this.Tag == input.Tag ||
                    (this.Tag != null &&
                    this.Tag.Equals(input.Tag))
                ) && 
                (
                    this.TimeSeries == input.TimeSeries ||
                    this.TimeSeries != null &&
                    input.TimeSeries != null &&
                    this.TimeSeries.SequenceEqual(input.TimeSeries)
                ) && 
                (
                    this.UpdatedAt == input.UpdatedAt ||
                    (this.UpdatedAt != null &&
                    this.UpdatedAt.Equals(input.UpdatedAt))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.CompanyId != null)
                    hashCode = hashCode * 59 + this.CompanyId.GetHashCode();
                if (this.GeneratedAt != null)
                    hashCode = hashCode * 59 + this.GeneratedAt.GetHashCode();
                if (this.Interval != null)
                    hashCode = hashCode * 59 + this.Interval.GetHashCode();
                if (this.Tag != null)
                    hashCode = hashCode * 59 + this.Tag.GetHashCode();
                if (this.TimeSeries != null)
                    hashCode = hashCode * 59 + this.TimeSeries.GetHashCode();
                if (this.UpdatedAt != null)
                    hashCode = hashCode * 59 + this.UpdatedAt.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
