/*
 * Data API
 *
 * Cognitive Credit Company Data API
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// DataInner
    /// </summary>
    [DataContract]
    public partial class DataInner :  IEquatable<DataInner>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DataInner" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected DataInner() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="DataInner" /> class.
        /// </summary>
        /// <param name="accountingStandard">accountingStandard (required).</param>
        /// <param name="countryCode">countryCode (required).</param>
        /// <param name="createdAt">createdAt.</param>
        /// <param name="currency">currency (required).</param>
        /// <param name="description">description (required).</param>
        /// <param name="frequency">frequency (required).</param>
        /// <param name="generatedAt">generatedAt (required).</param>
        /// <param name="gicsCode">gicsCode (required).</param>
        /// <param name="id">id (required).</param>
        /// <param name="lastReportedDate">lastReportedDate (required).</param>
        /// <param name="lastReportedDocumentType">lastReportedDocumentType (required).</param>
        /// <param name="lastReportedPeriod">lastReportedPeriod (required).</param>
        /// <param name="multiplier">multiplier (required).</param>
        /// <param name="name">name (required).</param>
        /// <param name="nextReportingDate">nextReportingDate.</param>
        /// <param name="nextReportingPeriod">nextReportingPeriod.</param>
        /// <param name="ownership">ownership (required).</param>
        /// <param name="retired">retired (required).</param>
        /// <param name="retiredDate">retiredDate.</param>
        /// <param name="ticker">ticker (required).</param>
        /// <param name="updatedAt">updatedAt (required).</param>
        /// <param name="urlInvestorsRelations">urlInvestorsRelations.</param>
        /// <param name="yearEnd">yearEnd (required).</param>
        public DataInner(string accountingStandard = default(string), string countryCode = default(string), DateTime createdAt = default(DateTime), string currency = default(string), string description = default(string), string frequency = default(string), DateTime generatedAt = default(DateTime), string gicsCode = default(string), string id = default(string), DateTime lastReportedDate = default(DateTime), string lastReportedDocumentType = default(string), string lastReportedPeriod = default(string), Multiplier multiplier = default(Multiplier), string name = default(string), string nextReportingDate = default(string), string nextReportingPeriod = default(string), string ownership = default(string), bool retired = default(bool), DateTime? retiredDate = default(DateTime?), string ticker = default(string), DateTime updatedAt = default(DateTime), string urlInvestorsRelations = default(string), string yearEnd = default(string))
        {
            // to ensure "accountingStandard" is required (not null)
            if (accountingStandard == null)
            {
                throw new InvalidDataException("accountingStandard is a required property for DataInner and cannot be null");
            }
            else
            {
                this.AccountingStandard = accountingStandard;
            }

            // to ensure "countryCode" is required (not null)
            if (countryCode == null)
            {
                throw new InvalidDataException("countryCode is a required property for DataInner and cannot be null");
            }
            else
            {
                this.CountryCode = countryCode;
            }

            // to ensure "currency" is required (not null)
            if (currency == null)
            {
                throw new InvalidDataException("currency is a required property for DataInner and cannot be null");
            }
            else
            {
                this.Currency = currency;
            }

            // to ensure "description" is required (not null)
            if (description == null)
            {
                throw new InvalidDataException("description is a required property for DataInner and cannot be null");
            }
            else
            {
                this.Description = description;
            }

            this.Description = description;
            // to ensure "frequency" is required (not null)
            if (frequency == null)
            {
                throw new InvalidDataException("frequency is a required property for DataInner and cannot be null");
            }
            else
            {
                this.Frequency = frequency;
            }

            // to ensure "generatedAt" is required (not null)
            if (generatedAt == null)
            {
                throw new InvalidDataException("generatedAt is a required property for DataInner and cannot be null");
            }
            else
            {
                this.GeneratedAt = generatedAt;
            }

            // to ensure "gicsCode" is required (not null)
            if (gicsCode == null)
            {
                throw new InvalidDataException("gicsCode is a required property for DataInner and cannot be null");
            }
            else
            {
                this.GicsCode = gicsCode;
            }

            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for DataInner and cannot be null");
            }
            else
            {
                this.Id = id;
            }

            // to ensure "lastReportedDate" is required (not null)
            if (lastReportedDate == null)
            {
                throw new InvalidDataException("lastReportedDate is a required property for DataInner and cannot be null");
            }
            else
            {
                this.LastReportedDate = lastReportedDate;
            }

            // to ensure "lastReportedDocumentType" is required (not null)
            if (lastReportedDocumentType == null)
            {
                throw new InvalidDataException("lastReportedDocumentType is a required property for DataInner and cannot be null");
            }
            else
            {
                this.LastReportedDocumentType = lastReportedDocumentType;
            }

            // to ensure "lastReportedPeriod" is required (not null)
            if (lastReportedPeriod == null)
            {
                throw new InvalidDataException("lastReportedPeriod is a required property for DataInner and cannot be null");
            }
            else
            {
                this.LastReportedPeriod = lastReportedPeriod;
            }

            // to ensure "multiplier" is required (not null)
            if (multiplier == null)
            {
                throw new InvalidDataException("multiplier is a required property for DataInner and cannot be null");
            }
            else
            {
                this.Multiplier = multiplier;
            }

            // to ensure "name" is required (not null)
            if (name == null)
            {
                throw new InvalidDataException("name is a required property for DataInner and cannot be null");
            }
            else
            {
                this.Name = name;
            }

            this.NextReportingDate = nextReportingDate;
            this.NextReportingPeriod = nextReportingPeriod;
            // to ensure "ownership" is required (not null)
            if (ownership == null)
            {
                throw new InvalidDataException("ownership is a required property for DataInner and cannot be null");
            }
            else
            {
                this.Ownership = ownership;
            }

            // to ensure "retired" is required (not null)
            if (retired == null)
            {
                throw new InvalidDataException("retired is a required property for DataInner and cannot be null");
            }
            else
            {
                this.Retired = retired;
            }

            this.RetiredDate = retiredDate;
            // to ensure "ticker" is required (not null)
            if (ticker == null)
            {
                throw new InvalidDataException("ticker is a required property for DataInner and cannot be null");
            }
            else
            {
                this.Ticker = ticker;
            }

            // to ensure "updatedAt" is required (not null)
            if (updatedAt == null)
            {
                throw new InvalidDataException("updatedAt is a required property for DataInner and cannot be null");
            }
            else
            {
                this.UpdatedAt = updatedAt;
            }

            this.UrlInvestorsRelations = urlInvestorsRelations;
            // to ensure "yearEnd" is required (not null)
            if (yearEnd == null)
            {
                throw new InvalidDataException("yearEnd is a required property for DataInner and cannot be null");
            }
            else
            {
                this.YearEnd = yearEnd;
            }

            this.CreatedAt = createdAt;
            this.NextReportingDate = nextReportingDate;
            this.NextReportingPeriod = nextReportingPeriod;
            this.RetiredDate = retiredDate;
            this.UrlInvestorsRelations = urlInvestorsRelations;
        }

        /// <summary>
        /// Gets or Sets AccountingStandard
        /// </summary>
        [DataMember(Name="accounting_standard", EmitDefaultValue=true)]
        public string AccountingStandard { get; set; }

        /// <summary>
        /// Gets or Sets CountryCode
        /// </summary>
        [DataMember(Name="country_code", EmitDefaultValue=true)]
        public string CountryCode { get; set; }

        /// <summary>
        /// Gets or Sets CreatedAt
        /// </summary>
        [DataMember(Name="created_at", EmitDefaultValue=false)]
        public DateTime CreatedAt { get; set; }

        /// <summary>
        /// Gets or Sets Currency
        /// </summary>
        [DataMember(Name="currency", EmitDefaultValue=true)]
        public string Currency { get; set; }

        /// <summary>
        /// Gets or Sets Description
        /// </summary>
        [DataMember(Name="description", EmitDefaultValue=true)]
        public string Description { get; set; }

        /// <summary>
        /// Gets or Sets Frequency
        /// </summary>
        [DataMember(Name="frequency", EmitDefaultValue=true)]
        public string Frequency { get; set; }

        /// <summary>
        /// Gets or Sets GeneratedAt
        /// </summary>
        [DataMember(Name="generated_at", EmitDefaultValue=true)]
        public DateTime GeneratedAt { get; set; }

        /// <summary>
        /// Gets or Sets GicsCode
        /// </summary>
        [DataMember(Name="gics_code", EmitDefaultValue=true)]
        public string GicsCode { get; set; }

        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=true)]
        public string Id { get; set; }

        /// <summary>
        /// Gets or Sets LastReportedDate
        /// </summary>
        [DataMember(Name="last_reported_date", EmitDefaultValue=true)]
        public DateTime LastReportedDate { get; set; }

        /// <summary>
        /// Gets or Sets LastReportedDocumentType
        /// </summary>
        [DataMember(Name="last_reported_document_type", EmitDefaultValue=true)]
        public string LastReportedDocumentType { get; set; }

        /// <summary>
        /// Gets or Sets LastReportedPeriod
        /// </summary>
        [DataMember(Name="last_reported_period", EmitDefaultValue=true)]
        public string LastReportedPeriod { get; set; }

        /// <summary>
        /// Gets or Sets Multiplier
        /// </summary>
        [DataMember(Name="multiplier", EmitDefaultValue=true)]
        public Multiplier Multiplier { get; set; }

        /// <summary>
        /// Gets or Sets Name
        /// </summary>
        [DataMember(Name="name", EmitDefaultValue=true)]
        public string Name { get; set; }

        /// <summary>
        /// Gets or Sets NextReportingDate
        /// </summary>
        [DataMember(Name="next_reporting_date", EmitDefaultValue=true)]
        public string NextReportingDate { get; set; }

        /// <summary>
        /// Gets or Sets NextReportingPeriod
        /// </summary>
        [DataMember(Name="next_reporting_period", EmitDefaultValue=true)]
        public string NextReportingPeriod { get; set; }

        /// <summary>
        /// Gets or Sets Ownership
        /// </summary>
        [DataMember(Name="ownership", EmitDefaultValue=true)]
        public string Ownership { get; set; }

        /// <summary>
        /// Gets or Sets Retired
        /// </summary>
        [DataMember(Name="retired", EmitDefaultValue=true)]
        public bool Retired { get; set; }

        /// <summary>
        /// Gets or Sets RetiredDate
        /// </summary>
        [DataMember(Name="retired_date", EmitDefaultValue=true)]
        [JsonConverter(typeof(OpenAPIDateConverter))]
        public DateTime? RetiredDate { get; set; }

        /// <summary>
        /// Gets or Sets Ticker
        /// </summary>
        [DataMember(Name="ticker", EmitDefaultValue=true)]
        public string Ticker { get; set; }

        /// <summary>
        /// Gets or Sets UpdatedAt
        /// </summary>
        [DataMember(Name="updated_at", EmitDefaultValue=true)]
        public DateTime UpdatedAt { get; set; }

        /// <summary>
        /// Gets or Sets UrlInvestorsRelations
        /// </summary>
        [DataMember(Name="url_investors_relations", EmitDefaultValue=true)]
        public string UrlInvestorsRelations { get; set; }

        /// <summary>
        /// Gets or Sets YearEnd
        /// </summary>
        [DataMember(Name="year_end", EmitDefaultValue=true)]
        public string YearEnd { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class DataInner {\n");
            sb.Append("  AccountingStandard: ").Append(AccountingStandard).Append("\n");
            sb.Append("  CountryCode: ").Append(CountryCode).Append("\n");
            sb.Append("  CreatedAt: ").Append(CreatedAt).Append("\n");
            sb.Append("  Currency: ").Append(Currency).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  Frequency: ").Append(Frequency).Append("\n");
            sb.Append("  GeneratedAt: ").Append(GeneratedAt).Append("\n");
            sb.Append("  GicsCode: ").Append(GicsCode).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  LastReportedDate: ").Append(LastReportedDate).Append("\n");
            sb.Append("  LastReportedDocumentType: ").Append(LastReportedDocumentType).Append("\n");
            sb.Append("  LastReportedPeriod: ").Append(LastReportedPeriod).Append("\n");
            sb.Append("  Multiplier: ").Append(Multiplier).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  NextReportingDate: ").Append(NextReportingDate).Append("\n");
            sb.Append("  NextReportingPeriod: ").Append(NextReportingPeriod).Append("\n");
            sb.Append("  Ownership: ").Append(Ownership).Append("\n");
            sb.Append("  Retired: ").Append(Retired).Append("\n");
            sb.Append("  RetiredDate: ").Append(RetiredDate).Append("\n");
            sb.Append("  Ticker: ").Append(Ticker).Append("\n");
            sb.Append("  UpdatedAt: ").Append(UpdatedAt).Append("\n");
            sb.Append("  UrlInvestorsRelations: ").Append(UrlInvestorsRelations).Append("\n");
            sb.Append("  YearEnd: ").Append(YearEnd).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as DataInner);
        }

        /// <summary>
        /// Returns true if DataInner instances are equal
        /// </summary>
        /// <param name="input">Instance of DataInner to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DataInner input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.AccountingStandard == input.AccountingStandard ||
                    (this.AccountingStandard != null &&
                    this.AccountingStandard.Equals(input.AccountingStandard))
                ) && 
                (
                    this.CountryCode == input.CountryCode ||
                    (this.CountryCode != null &&
                    this.CountryCode.Equals(input.CountryCode))
                ) && 
                (
                    this.CreatedAt == input.CreatedAt ||
                    (this.CreatedAt != null &&
                    this.CreatedAt.Equals(input.CreatedAt))
                ) && 
                (
                    this.Currency == input.Currency ||
                    (this.Currency != null &&
                    this.Currency.Equals(input.Currency))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.Frequency == input.Frequency ||
                    (this.Frequency != null &&
                    this.Frequency.Equals(input.Frequency))
                ) && 
                (
                    this.GeneratedAt == input.GeneratedAt ||
                    (this.GeneratedAt != null &&
                    this.GeneratedAt.Equals(input.GeneratedAt))
                ) && 
                (
                    this.GicsCode == input.GicsCode ||
                    (this.GicsCode != null &&
                    this.GicsCode.Equals(input.GicsCode))
                ) && 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.LastReportedDate == input.LastReportedDate ||
                    (this.LastReportedDate != null &&
                    this.LastReportedDate.Equals(input.LastReportedDate))
                ) && 
                (
                    this.LastReportedDocumentType == input.LastReportedDocumentType ||
                    (this.LastReportedDocumentType != null &&
                    this.LastReportedDocumentType.Equals(input.LastReportedDocumentType))
                ) && 
                (
                    this.LastReportedPeriod == input.LastReportedPeriod ||
                    (this.LastReportedPeriod != null &&
                    this.LastReportedPeriod.Equals(input.LastReportedPeriod))
                ) && 
                (
                    this.Multiplier == input.Multiplier ||
                    (this.Multiplier != null &&
                    this.Multiplier.Equals(input.Multiplier))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.NextReportingDate == input.NextReportingDate ||
                    (this.NextReportingDate != null &&
                    this.NextReportingDate.Equals(input.NextReportingDate))
                ) && 
                (
                    this.NextReportingPeriod == input.NextReportingPeriod ||
                    (this.NextReportingPeriod != null &&
                    this.NextReportingPeriod.Equals(input.NextReportingPeriod))
                ) && 
                (
                    this.Ownership == input.Ownership ||
                    (this.Ownership != null &&
                    this.Ownership.Equals(input.Ownership))
                ) && 
                (
                    this.Retired == input.Retired ||
                    (this.Retired != null &&
                    this.Retired.Equals(input.Retired))
                ) && 
                (
                    this.RetiredDate == input.RetiredDate ||
                    (this.RetiredDate != null &&
                    this.RetiredDate.Equals(input.RetiredDate))
                ) && 
                (
                    this.Ticker == input.Ticker ||
                    (this.Ticker != null &&
                    this.Ticker.Equals(input.Ticker))
                ) && 
                (
                    this.UpdatedAt == input.UpdatedAt ||
                    (this.UpdatedAt != null &&
                    this.UpdatedAt.Equals(input.UpdatedAt))
                ) && 
                (
                    this.UrlInvestorsRelations == input.UrlInvestorsRelations ||
                    (this.UrlInvestorsRelations != null &&
                    this.UrlInvestorsRelations.Equals(input.UrlInvestorsRelations))
                ) && 
                (
                    this.YearEnd == input.YearEnd ||
                    (this.YearEnd != null &&
                    this.YearEnd.Equals(input.YearEnd))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.AccountingStandard != null)
                    hashCode = hashCode * 59 + this.AccountingStandard.GetHashCode();
                if (this.CountryCode != null)
                    hashCode = hashCode * 59 + this.CountryCode.GetHashCode();
                if (this.CreatedAt != null)
                    hashCode = hashCode * 59 + this.CreatedAt.GetHashCode();
                if (this.Currency != null)
                    hashCode = hashCode * 59 + this.Currency.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.Frequency != null)
                    hashCode = hashCode * 59 + this.Frequency.GetHashCode();
                if (this.GeneratedAt != null)
                    hashCode = hashCode * 59 + this.GeneratedAt.GetHashCode();
                if (this.GicsCode != null)
                    hashCode = hashCode * 59 + this.GicsCode.GetHashCode();
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.LastReportedDate != null)
                    hashCode = hashCode * 59 + this.LastReportedDate.GetHashCode();
                if (this.LastReportedDocumentType != null)
                    hashCode = hashCode * 59 + this.LastReportedDocumentType.GetHashCode();
                if (this.LastReportedPeriod != null)
                    hashCode = hashCode * 59 + this.LastReportedPeriod.GetHashCode();
                if (this.Multiplier != null)
                    hashCode = hashCode * 59 + this.Multiplier.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.NextReportingDate != null)
                    hashCode = hashCode * 59 + this.NextReportingDate.GetHashCode();
                if (this.NextReportingPeriod != null)
                    hashCode = hashCode * 59 + this.NextReportingPeriod.GetHashCode();
                if (this.Ownership != null)
                    hashCode = hashCode * 59 + this.Ownership.GetHashCode();
                if (this.Retired != null)
                    hashCode = hashCode * 59 + this.Retired.GetHashCode();
                if (this.RetiredDate != null)
                    hashCode = hashCode * 59 + this.RetiredDate.GetHashCode();
                if (this.Ticker != null)
                    hashCode = hashCode * 59 + this.Ticker.GetHashCode();
                if (this.UpdatedAt != null)
                    hashCode = hashCode * 59 + this.UpdatedAt.GetHashCode();
                if (this.UrlInvestorsRelations != null)
                    hashCode = hashCode * 59 + this.UrlInvestorsRelations.GetHashCode();
                if (this.YearEnd != null)
                    hashCode = hashCode * 59 + this.YearEnd.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
